/*

The ubports-ci-dispatcher daemon listens for webhook event notifications and
invokes actions in response.

Usage:

	ubports-ci-dispatcher [-config config] [-debug]

Description:

The UBports CI Dispatcher listens for webhook event notifications from the
UBports CI system and invokes certain actions in response.  More specifically,
it downloads Debian packages generated by the GitLab CI system, processes them
and then adds them to a package repository managed by Aptly.

Options:

	-config config
		Set the name of the configuration file to config.

	-debug
		Enable debug logging.

Configuration File:

If a configuration file is not explicitly specified using the -config option
ubports-ci-dispatcher will open the default configuration file
/etc/ubports-ci-dispatcher.conf.

The configuration file uses the TOML file format.

The following configuration options are recognized:

	listen_address
		IP address and port to listen on.

	tokens
		Array of tokens used to authenticate webhook requests.

	incoming_path
		Path where downloaded files are temporarily stored.

	gitlab_url
		API URL of the GitLab instance which makes webhook requests.
		If no URL is specified it defaults to
		"https://gitlab.com/api/v4".

	aptly_url
		API URL of the Aptly instance managing the Debian package
		repository.  If no URL is specified it defaults to
		"http://localhost:8080/api".

	repo
		Name of the Aptly repository to which new packages should be
		added.  If no name is specified it defaults to "ubports-ci".

	logfile
		Name of the logfile.  If no name is given log messages will be
		written to stderr.

Deployment:

ubports-ci-dispatcher should be run from a non-privileged user account using a
service manager and behind a HTTPS termination proxy.  An instance of Aptly
must be reachable via HTTP(S).

GitLab webhooks of projects/groups should be configured to call a URL using the
scheme "https://<hostname:port>/gitlab-webhook" with a sufficiently long
secret token specified in the "tokens" configuration option.
*/
package main
